mod diffuse;
mod minmaxtree;
mod random;

pub use diffuse::DiffuseAgent;
pub use minmaxtree::MinMaxTree;
pub use random::RandomAgent;

use crate::board::{Board, PlayerAction};

/// An agent that tries to minimize the value of a board.
pub trait MinimizerAgent {
	fn step_min(&mut self, board: &Board) -> PlayerAction;
}

/// An agent that tries to maximize the value of a board.
pub trait MaximizerAgent {
	fn step_max(&mut self, board: &Board) -> PlayerAction;
}
